﻿using System.Diagnostics;
using System.Windows.Controls.Primitives;
using System.Windows.Threading;

namespace PowernapPeerWPF
{
    class TextBoxTraceListener : TraceListener
    {
        private readonly TextBoxBase _textBox;
        private readonly Dispatcher _dispatcher;

        public TextBoxTraceListener(Dispatcher dispatcher, TextBoxBase textBox)
        {
            _textBox = textBox;
            _dispatcher = dispatcher;
        }

        public override void Write(string message)
        {
            // http://stackoverflow.com/questions/10795948/the-calling-thread-cannot-access-this-object-because-a-different-thread-owns-it
            if (_dispatcher.CheckAccess())
            {
                _textBox.AppendText(message);
            }
            else
            {
                _dispatcher.Invoke(() => _textBox.AppendText(message));
            }
        }

        public override void WriteLine(string message)
        {
            Write(message + "\n");
        }

    }
}
